#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\radiobut.h>
#include <owl\edit.h>
#include <owl\dc.h>
#include <owl\validate.h>
#include <string.h>
#include <cstring.h>
#include "Bashe.rc"

struct TTransBuf
{
  char N[3];  //  .
}transBuf;


//  .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//   .
class TWndw : public  TFrameWindow
{
  public:
	 TWndw (TWindow *parent, const char far *title);
  protected:
			int flag,n,k;
			TClientDC *clientDC;
			TBitmap *bitmapl,*bitmapl1;
			void SetupWindow();
			void CleanUpWindow();
			void CmGetData();
			void CmGetData2();
			void CmGetData3();
			void Ubrat(int);
			void DrawObject (TPoint &point, TBitmap *bitmap);
			void Paint(TDC&, BOOL, TRect&);
			void CmGame();

			DECLARE_RESPONSE_TABLE(TWndw);

};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
	  EV_COMMAND (CM_GETDATA, CmGetData),
	  EV_COMMAND (CM_GETDATA2, CmGetData2),
	  EV_COMMAND (CM_GETDATA3, CmGetData3),
	  EV_COMMAND(CM_GAME,CmGame),
END_RESPONSE_TABLE;


//  
class TDlg:public TDialog
{
  public:
	  TDlg(TWindow *parent, TResId resld);
  protected:
	  void SetupWindow();
	  BOOL CanClose();
};

// TWndw::TWndw()
//    .
TWndw::TWndw(TWindow *parent, const char far *title):
			 TFrameWindow (parent, title)
{
  //      
  //  .
  EnableKBHandler();
  //   .
  AssignMenu(MENU_1);
  //     .
  Attr.X = 230;
  Attr.Y = 60;
  Attr.W=680;
  Attr.H=600;
  //   .
  memset (&transBuf, 0, sizeof(transBuf)); 
  //     .
  new TButton(this, CM_GAME, " ", 240, 40, 150, 20);
  new TButton(this, CM_GETDATA, "  ", 240, 80, 150, 20);
  new TButton(this, CM_GETDATA2, "  ", 240, 105, 150, 20);
  new TButton(this, CM_GETDATA3, "  ", 240, 130, 150, 20);
}

//      NEW_GAME
void TWndw::CmGame()
{
  //   .
  TDialog *dialog = new TDlg(this, ADDRDLG);
  //   .
  int result = dialog->Execute();
  //     ...
  if (result == IDOK)
	  //    
	  //     .
	{
	//-  ,   
	  n=atoi(transBuf.N); 
 	//   .	 
 	  Invalidate();
	//   ,    .
	  Ubrat(0);
  	}
}

// ************************
//   TDlg.
// ************************
// TDlg::TDlg()
//   .
TDlg::TDlg(TWindow *parent,TResId resId):
			TDialog(parent,resId)
{
  TEdit *edit;
  TValidator  *valid;

  //     OWL   
  //       ,   
  //     ,      
  // -  
  // ,          .
  edit=new TEdit(this,ID_EDIT,sizeof(transBuf.N));
  valid = new  TFilterValidator("0-9");
  edit->SetValidator(valid);
  //    .
  TransferBuffer=&transBuf;
}


// TDlg::SetupWindow()
//    SetupWindow() 
// TDialog     
//   .    
//  .
void TDlg::SetupWindow()
{
  // !    .
  TDialog::SetupWindow();
}

// TDlg::CanClose()
//
//  ,   
// TWindows,   
//    
//  .
BOOL TDlg::CanClose()
{
  //     .
  TransferData(tdGetData);
  // ,     
  //       .
  if ( (strlen(transBuf.N)==0)||(atoi(transBuf.N)==0) )
	  {
	  //   ,  
	  //     
	  //     .
		MessageBox ("    .", "", MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	  }
	  else
		  return TRUE;
}

// TWndw::SetupWindow()
//  ,  
// SetupWindow()  , 
//     .
void TWndw::SetupWindow()
{
  //   SetupWindow()  .
  TFrameWindow::SetupWindow();
  //  DC ( )  -
  // .  ,   
  //  DC      
  //        .
  // ,      
  //   .
  clientDC = new TClientDC(HWindow);
	//    .
  HINSTANCE instance = *GetApplication();
  //    
  bitmapl = new TBitmap (instance, BITMAP_1);
  bitmapl1 = new TBitmap (instance, BITMAP_2);
}

// TWndw::CleanUpWindow()
//    , 
//  TFrameWindow.   
//   .
void TWndw::CleanUpWindow()
{
  //  GDI-  DC.
  delete bitmapl;
  delete bitmapl1;
  delete clientDC;
}




// TWndw::Paint()
//  ,    
// WM_PAINT,   , 
//    .
void TWndw::Paint(TDC&, BOOL, TRect&)
{
  TPoint point;
  point.x=0;
  point.y=0;
//    bitmapl1   point
  DrawObject (point, bitmapl1);
  if (n||k) 
  {
	 char s1[5],s[30]="  ";
	 itoa(k,s1,10);//k--   
	 strcat(s,s1);
	 strcat(s,", n= ");
	 itoa(n,s1,10);//n--    
	 strcat(s,s1);
//         
	 (*clientDC).TextOut(240,165,s);
  }
//  ,   .
 for(int i=0;i<n;i++)
  {
	 point.x=10+i%22*30;
	 point.y=250+i/22*40;
//    bitmapl   point
//( )
	 DrawObject (point, bitmapl);
  }
}

// TWndw::DrawObject()
//      
//   ,    TPoint.
void TWndw::DrawObject(TPoint  &point, TBitmap *bitmap)
{
  BITMAP  bm;
 //   
 //  ,  
//   .
  TMemoryDC memDC (*clientDC);
//   
//    .
  memDC.SelectObject (*bitmap);
//    .
  bitmap->GetObject (bm);
//  
//    .
  clientDC->BitBlt(point.x, point.y, bm.bmWidth,
			 bm.bmHeight, memDC, 0,0, SRCCOPY);
}


// TWndw::CmGetData()
//      Get_Data 
//(   "  ")
void TWndw::CmGetData()
{
  TWndw::Ubrat(1);
}
//      Get_Data2 
//(   "  ")
void TWndw::CmGetData2()
{
 TWndw::Ubrat(2);
}

//      Get_Data3 
//(   "  ")
void TWndw::CmGetData3()
{
 TWndw::Ubrat(3);
}

void TWndw::Ubrat(int j)
{
  flag=1;
  if (!j)// j=0,    .
  {
	 if  (!(n%4))  //-   4,    ,   
	  {		//    .
		if( MessageBox("      ?","", MB_YESNO | MB_ICONQUESTION)==IDYES)
			 flag=0; //       
	  }
	if (flag) //  .
	{
	 flag=0;
	 MessageBox("  ","",MB_OK | MB_ICONASTERISK);
	  if (n%4)	//     4
		k=n%4;  //   ,     4,
			//..  -        4
	  else
		if (n%3) // -   4,   ,
			k=n%3; // -       3,  -    3
		else		// -   ,   3 .(  random(2)+1).
			k=3;
	 n=n-k;// -    - .
	if(!n) //  ,   .
		MessageBox(" ","", MB_OK | MB_ICONASTERISK);
	}
  }
  else // j!=0,     j- -   
  {
  //       , -   ,
  // -   .
  char s[10],s1[13]="  ";
  itoa(j,s,10);   
  strcat(s1,s);
  strcat(s1," n=");
  n=n-j;// -    - .
  itoa(n,s,10);
  strcat(s1,s);
  MessageBox(s1,"", MB_OK | MB_ICONASTERISK);
  //   .
  Invalidate();
  if(!n)//  ,   .
		MessageBox(" ","", MB_OK | MB_ICONASTERISK);
  else //  ,  .
  {
	 if (n%4)       //     4
		k=n%4;  //   ,     4,
	  else		//..  -        4
		if (n%3)	// -   4,   ,
			k=n%3;  // -       3,  -    3
		else		// -   ,   3 .(  random(2)+1).
			k=3;
  n=n-k;  // -    - .
  if(!n)  //  ,   .
		MessageBox(" ","",
					 MB_OK | MB_ICONASTERISK);
  }
 }
 //   .
Invalidate();
}



void TApp::InitMainWindow()
{
  TFrameWindow *wndw = new TWndw (0," ");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
